Linux Audio

Check our new training course

Loading...
v4.17
 1#!/bin/sh
 2# SPDX-License-Identifier: GPL-2.0
 3# Check ncurses compatibility
 4
 5# What library to link
 6ldflags()
 7{
 8	pkg-config --libs ncursesw 2>/dev/null && exit
 9	pkg-config --libs ncurses 2>/dev/null && exit
10	for ext in so a dll.a dylib ; do
11		for lib in ncursesw ncurses curses ; do
12			$cc -print-file-name=lib${lib}.${ext} | grep -q /
13			if [ $? -eq 0 ]; then
14				echo "-l${lib}"
15				exit
16			fi
17		done
18	done
19	exit 1
20}
21
22# Where is ncurses.h?
23ccflags()
24{
25	if pkg-config --cflags ncursesw 2>/dev/null; then
26		echo '-DCURSES_LOC="<ncurses.h>" -DNCURSES_WIDECHAR=1'
27	elif pkg-config --cflags ncurses 2>/dev/null; then
28		echo '-DCURSES_LOC="<ncurses.h>"'
29	elif [ -f /usr/include/ncursesw/curses.h ]; then
30		echo '-I/usr/include/ncursesw -DCURSES_LOC="<curses.h>"'
31		echo ' -DNCURSES_WIDECHAR=1'
32	elif [ -f /usr/include/ncurses/ncurses.h ]; then
33		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
34	elif [ -f /usr/include/ncurses/curses.h ]; then
35		echo '-I/usr/include/ncurses -DCURSES_LOC="<curses.h>"'
 
 
36	elif [ -f /usr/include/ncurses.h ]; then
37		echo '-DCURSES_LOC="<ncurses.h>"'
38	else
39		echo '-DCURSES_LOC="<curses.h>"'
40	fi
41}
42
43# Temp file, try to clean up after us
44tmp=.lxdialog.tmp
45trap "rm -f $tmp" 0 1 2 3 15
46
47# Check if we can link to ncurses
48check() {
49        $cc -x c - -o $tmp 2>/dev/null <<'EOF'
50#include CURSES_LOC
51main() {}
52EOF
53	if [ $? != 0 ]; then
54	    echo " *** Unable to find the ncurses libraries or the"       1>&2
55	    echo " *** required header files."                            1>&2
56	    echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
57	    echo " *** "                                                  1>&2
58	    echo " *** Install ncurses (ncurses-devel or libncurses-dev " 1>&2
59	    echo " *** depending on your distribution) and try again."    1>&2
60	    echo " *** "                                                  1>&2
61	    exit 1
62	fi
63}
64
65usage() {
66	printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n"
67}
68
69if [ $# -eq 0 ]; then
70	usage
71	exit 1
72fi
73
74cc=""
75case "$1" in
76	"-check")
77		shift
78		cc="$@"
79		check
80		;;
81	"-ccflags")
82		ccflags
83		;;
84	"-ldflags")
85		shift
86		cc="$@"
87		ldflags
88		;;
89	"*")
90		usage
91		exit 1
92		;;
93esac
v3.1
 1#!/bin/sh
 
 2# Check ncurses compatibility
 3
 4# What library to link
 5ldflags()
 6{
 7	for ext in so a dylib ; do
 
 
 8		for lib in ncursesw ncurses curses ; do
 9			$cc -print-file-name=lib${lib}.${ext} | grep -q /
10			if [ $? -eq 0 ]; then
11				echo "-l${lib}"
12				exit
13			fi
14		done
15	done
16	exit 1
17}
18
19# Where is ncurses.h?
20ccflags()
21{
22	if [ -f /usr/include/ncurses/ncurses.h ]; then
 
 
 
 
 
 
 
23		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"'
24	elif [ -f /usr/include/ncurses/curses.h ]; then
25		echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"'
26	elif [ -f /usr/include/ncursesw/curses.h ]; then
27		echo '-I/usr/include/ncursesw -DCURSES_LOC="<ncursesw/curses.h>"'
28	elif [ -f /usr/include/ncurses.h ]; then
29		echo '-DCURSES_LOC="<ncurses.h>"'
30	else
31		echo '-DCURSES_LOC="<curses.h>"'
32	fi
33}
34
35# Temp file, try to clean up after us
36tmp=.lxdialog.tmp
37trap "rm -f $tmp" 0 1 2 3 15
38
39# Check if we can link to ncurses
40check() {
41        $cc -xc - -o $tmp 2>/dev/null <<'EOF'
42#include CURSES_LOC
43main() {}
44EOF
45	if [ $? != 0 ]; then
46	    echo " *** Unable to find the ncurses libraries or the"       1>&2
47	    echo " *** required header files."                            1>&2
48	    echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2
49	    echo " *** "                                                  1>&2
50	    echo " *** Install ncurses (ncurses-devel) and try again."    1>&2
 
51	    echo " *** "                                                  1>&2
52	    exit 1
53	fi
54}
55
56usage() {
57	printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n"
58}
59
60if [ $# -eq 0 ]; then
61	usage
62	exit 1
63fi
64
65cc=""
66case "$1" in
67	"-check")
68		shift
69		cc="$@"
70		check
71		;;
72	"-ccflags")
73		ccflags
74		;;
75	"-ldflags")
76		shift
77		cc="$@"
78		ldflags
79		;;
80	"*")
81		usage
82		exit 1
83		;;
84esac